/*
Example for Keylock Click

    Date          : jul 2017.
    Author        : MikroE Team

Test configuration CEC :
    
    MCU             : CEC1702
    Dev. Board      : Clicker 2 for CEC1702
    SW              : mikroC PRO for ARM v5.1.0

Description :

   This is a simple example of how Keylock click works, depending on the state of the Keylock click the appropriate position will be detected.

*/

#include "stdint.h"

sbit KEYLOCK_STATE_1 at GPIO_INPUT_200_207.B0;
sbit KEYLOCK_STATE_2 at GPIO_INPUT_130_137.B4;
sbit KEYLOCK_STATE_3 at GPIO_INPUT_030_037.B0;

uint8_t state;
char text[20];

void systemInit()
{ 
    Gpio_Digital_Output(&GPIO_PORT_130_137, _GPIO_PINMASK_5);
    GPIO_OUTPUT_130_137 = 0;
    GPIO_OUTPUT_130_137.B5 = 0;
    delay_ms(100);
    GPIO_OUTPUT_130_137.B5 = 1;
    delay_ms(100);

    Delay_ms (10000);
    UART1_Init_Advanced( 9600, _UART_8_BIT_DATA, _UART_NOPARITY,
                         _UART_ONE_STOPBIT );

    Delay_ms(100);
}

void Keylock_Init()
{   
    Gpio_Digital_Input (&GPIO_PORT_200_207, _GPIO_PINMASK_0);
    Gpio_Digital_Input (&GPIO_PORT_130_137, _GPIO_PINMASK_4);
    Gpio_Digital_Input (&GPIO_PORT_030_037, _GPIO_PINMASK_0);
    
}

void Keylock_Task()
{
    state =  KEYLOCK_STATE_1*1 + KEYLOCK_STATE_2*2 + KEYLOCK_STATE_3*3;
    UART1_Write_text("Keylock is in state:");
    IntToStr(state,text) ;
    UART1_Write_Text(text);
    UART1_Write_Text( "\r\n" );
    delay_ms(500);
}

void main()
{
    systemInit();
    Keylock_Init();

    while( 1 )
    {
            Keylock_Task();
    }
}

