/*
Example for Keylock Click

    Date          : jul 2017.
    Author        : MikroE Team

Test configuration MSP :
    
    MCU             : MSP432
    Dev. Board      : Clicker 2 for MSP432
    SW              : mikroC PRO for ARM v5.1.0

Description :

   This is a simple example of how Keylock click works, depending on the state of the Keylock click the appropriate position will be detected.

*/

#include "stdint.h"

sbit KEYLOCK_STATE_1 at DIO_P6IN.B0;
sbit KEYLOCK_STATE_2 at DIO_P2IN.B7;
sbit KEYLOCK_STATE_3 at DIO_P2IN.B4;

uint8_t state;
char text[20];

void systemInit()
{ 
    UART0_Init(9600);
}

void Keylock_Init()
{   
    GPIO_Digital_Input( &DIO_P6IN, _GPIO_PINMASK_0 );
    GPIO_Digital_Input( &DIO_P2IN, _GPIO_PINMASK_7 );
    GPIO_Digital_Input( &DIO_P2IN, _GPIO_PINMASK_4 );
    
}

void Keylock_Task()
{
    state =  KEYLOCK_STATE_1*1 + KEYLOCK_STATE_2*2 + KEYLOCK_STATE_3*3;
    UART0_Write_text("Keylock is in state:");
    IntToStr(state,text) ;
    UART0_Write_Text(text);
    UART0_Write_Text( "\r\n" );
    delay_ms(500);
}

void main()
{
    systemInit();
    Keylock_Init();

    while( 1 )
    {
            Keylock_Task();
    }
}