/*
Example for Keylock Click

    Date          : jul 2017.
    Author        : MikroE Team

Test configuration STM32 :
    
    MCU             : STM32F107VCT6
    Dev. Board      : EasyMx PRO v7 for STM32 ARM
    SW              : mikroC PRO for ARM v5.1.0

Description :

   This is a simple example of how Keylock click works, depending on the state of the Keylock click the appropriate position will be detected.

*/

#include "stdint.h"

sbit KEYLOCK_STATE_1 at GPIOA_IDR.B4; 
sbit KEYLOCK_STATE_2 at GPIOA_IDR.B0;
sbit KEYLOCK_STATE_3 at GPIOD_IDR.B10;
uint8_t state;
char txt[20];

void systemInit()
{ 
    UART1_Init(9600);
}

void Keylock_Init()
{   
    GPIO_Digital_Input( &GPIOA_BASE, _GPIO_PINMASK_4);
    GPIO_Digital_Input( &GPIOA_BASE, _GPIO_PINMASK_0 );
    GPIO_Digital_Input( &GPIOD_BASE, _GPIO_PINMASK_10 );
}

void Keylock_Task()
{
    state =  KEYLOCK_STATE_1*1 + KEYLOCK_STATE_2*2 + KEYLOCK_STATE_3*3;
    UART1_Write_text("Keylock is in state:");
    IntToStr(state,txt) ;
    UART1_Write_Text(txt);
    UART1_Write_Text( "\r\n" );
    delay_ms(500);
}

void main()
{
    systemInit();
    Keylock_Init();

    while( 1 )
    {
            Keylock_Task();
    }
}