/*
Example for Keylock Click

    Date          : jul 2017.
    Author        : MikroE Team

Test configuration TIVA :
    
    MCU             : TM4C129XNCZAD
    Dev. Board      : EasyMx PRO v7 for TIVA ARM
    SW              : mikroC PRO for ARM v5.1.0

Description :

   This is a simple example of how Keylock click works, depending on the state of the Keylock click the appropriate position will be detected.

*/

#include "stdint.h"

sbit KEYLOCK_STATE_1 at GPIO_PORTE_AHB_DATA.B4; 
sbit KEYLOCK_STATE_2 at GPIO_PORTD_AHB_DATA.B0;
sbit KEYLOCK_STATE_3 at GPIO_PORTF_AHB_DATA.B4;

uint8_t state;
char txt[20];

void systemInit()
{ 
    UART2_Init(9600);
}

void Keylock_Init()
{   
   GPIO_Digital_Input(&GPIO_PORTE_AHB, _GPIO_PINMASK_4 );
   GPIO_Digital_Input(&GPIO_PORTD_AHB, _GPIO_PINMASK_0 );
   GPIO_Digital_Input(&GPIO_PORTF_AHB, _GPIO_PINMASK_4 );
}

void Keylock_Task()
{
    state =  KEYLOCK_STATE_1*1 + KEYLOCK_STATE_2*2 + KEYLOCK_STATE_3*3;
    UART2_Write_text("Keylock is in state:");
    IntToStr(state,txt) ;
    UART2_Write_Text(txt);
    UART2_Write_Text( "\r\n" );
    delay_ms(500);
}

void main()
{
    systemInit();
    Keylock_Init();

    while( 1 )
    {
            Keylock_Task();
    }
}